<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
    <xsl:output method="xml" indent="yes" />
    <xsl:template name="Planowanie" match="/Sprawozdanie">
       <Planowanie>
          <Opis>DOSKOMP PlanB </Opis>
          <Slowniki>
              <Jednostki>
                  <!-- D - jednostka realizująca zadanie (dysponent) -->
                  <xsl:apply-templates select="Parametry/opisy/D/child::*" ></xsl:apply-templates>
              </Jednostki>
              <Zadania>
                   <xsl:call-template name="Zadanie"></xsl:call-template>        
              </Zadania>
              <Zrodla>   
                  <xsl:call-template name="Zrodlo"></xsl:call-template>        
              </Zrodla>
          </Slowniki>
          <Dokumenty>
              <Plany></Plany>
              <Wnioski></Wnioski>           
              <Wykonania>              
                  <xsl:apply-templates select="/Sprawozdanie/Dochody/Dane/*[generate-id(.)=generate-id(key('DBd',@DB)[1])]"/>   
                  <xsl:apply-templates select="/Sprawozdanie/Wydatki/Dane/*[generate-id(.)=generate-id(key('DBw',@DB)[1])]"/> 
              </Wykonania>
          </Dokumenty>        
     </Planowanie>
      
    </xsl:template>  
    
    <xsl:key name="DBd" match="/Sprawozdanie/Dochody/Dane/*" use="@DB" />
    <xsl:key name="DBw" match="/Sprawozdanie/Wydatki/Dane/*" use="@DB" />
    
    
    <xsl:template name="WykonanieDochody" match="/Sprawozdanie/Dochody/Dane/*">
        <Wykonanie>
            <NaglowekWykonanie>
                <ROKB><xsl:value-of select="substring(/Sprawozdanie/@Data,7,4)"></xsl:value-of></ROKB>
                <DATA_PWYK>
                    <xsl:value-of select="substring(/Sprawozdanie/@Data,7,4)">
                    </xsl:value-of>-<xsl:value-of select="substring(/Sprawozdanie/@Data,4,2)">
                    </xsl:value-of>-<xsl:value-of select="substring(/Sprawozdanie/@Data,1,2)">
                    </xsl:value-of>
                </DATA_PWYK>
                <REGON>000000000</REGON>
                <KOD_JB><xsl:value-of select="@DB"></xsl:value-of> </KOD_JB>
                <TYP_WYK>PR</TYP_WYK>
            </NaglowekWykonanie>      
            <Pozycje>
                 <xsl:for-each select="key('DBd', @DB)"> 
                     <Pozycja>
                         <DZIAL><xsl:value-of select="@DZIAL"/></DZIAL>
                         <ROZDZIAL><xsl:value-of select="@ROZDZIAL"/></ROZDZIAL>
                         <PAR><xsl:value-of select="substring(@PAR,1,3)"/></PAR>
                         <PAR4><xsl:value-of select="substring(@PAR,4,1)"/></PAR4>
                         <KOD_Z><xsl:value-of select="@ZADANIE"/></KOD_Z>
                         <KOD_ZR><xsl:value-of select="@RODZ"/></KOD_ZR>
                         <WARTOSC><xsl:value-of select="@FWYK"/></WARTOSC>
                         <PRZEPLYW>D</PRZEPLYW>
                     </Pozycja>    
                 </xsl:for-each>
            </Pozycje>
                
        </Wykonanie>              
    </xsl:template>
    
    
    <xsl:template name="WykonanieWydatki" match="/Sprawozdanie/Wydatki/Dane/*">
        <Wykonanie>
            <NaglowekWykonanie>
                <ROKB><xsl:value-of select="substring(/Sprawozdanie/@Data,7,4)"></xsl:value-of></ROKB>
                <DATA_PWYK>
                    <xsl:value-of select="substring(/Sprawozdanie/@Data,7,4)">
                    </xsl:value-of>-<xsl:value-of select="substring(/Sprawozdanie/@Data,4,2)">
                    </xsl:value-of>-<xsl:value-of select="substring(/Sprawozdanie/@Data,1,2)">
                    </xsl:value-of>
                </DATA_PWYK>
                <REGON>000000000</REGON>
                <KOD_JB><xsl:value-of select="@DB"></xsl:value-of> </KOD_JB>
                <TYP_WYK>PR</TYP_WYK>
            </NaglowekWykonanie>      
            <Pozycje>
                <xsl:for-each select="key('DBw', @DB)"> 
                    <Pozycja>
                        <DZIAL><xsl:value-of select="@DZIAL"/></DZIAL>
                        <ROZDZIAL><xsl:value-of select="@ROZDZIAL"/></ROZDZIAL>
                        <PAR><xsl:value-of select="substring(@PAR,1,3)"/></PAR>
                        <PAR4><xsl:value-of select="substring(@PAR,4,1)"/></PAR4>
                        <KOD_Z><xsl:value-of select="@ZADANIE"/></KOD_Z>
                        <KOD_ZR><xsl:value-of select="@RODZ"/></KOD_ZR>
                        <WARTOSC><xsl:value-of select="@FWYK"/></WARTOSC>
                        <PRZEPLYW>W</PRZEPLYW>
                    </Pozycja>    
                </xsl:for-each>
            </Pozycje>
            
        </Wykonanie>              
    </xsl:template>
    
    
    <xsl:template name="Jednostka" match="Parametry/opisy/D/child::*">
        <!-- D - jednostka realizująca zadanie (dysponent) -->
        <!--<xsl:for-each select="Parametry/opisy/D/child::*"> -->
            <Jednostka>
                <KOD_JB><xsl:value-of select="substring(name(),2,3)"></xsl:value-of></KOD_JB>
                <NAZWA><xsl:value-of select="@opis"></xsl:value-of></NAZWA>
                <REGON>000000000</REGON>
                <WK>00</WK>
                <PK>00</PK>
                <GK>00</GK>
                <GT>0</GT>
                <PT>0</PT>
                <TYP_JB>JB</TYP_JB>                      
            </Jednostka>
        <!--</xsl:for-each>    -->
    </xsl:template>
    
    <xsl:template name="Zadanie">   
        <!-- Z - Zadania wydatkowe -->
        <xsl:for-each select="Parametry/opisy/Z/child::*">
            <Zadanie>
                <KOD_Z><xsl:value-of select="substring(name(),3,13)"></xsl:value-of></KOD_Z>
                <NAZWA><xsl:value-of select="@opis"></xsl:value-of></NAZWA>
                <PRZEPLYW>
                    <!--Zadanie Dochodowe lub Wydatkowe -->
                    <xsl:if test="substring(name(),2,1)='1'">D</xsl:if>
                    <xsl:if test="substring(name(),2,1)='2'">W</xsl:if>   
                </PRZEPLYW>
                <RODZAJ>B</RODZAJ>
                <TYP_PG>G</TYP_PG>
                <REGON>000000000</REGON>
                <KOD_JB>0</KOD_JB>
                <GRUPA_WZP>0</GRUPA_WZP> 
            </Zadanie>
        </xsl:for-each>       
    </xsl:template>
    
    <xsl:template name="Zrodlo">
        <!-- R - źródło finansowania-->
        <xsl:for-each select="Parametry/opisy/R/child::*">
            <Zrodlo>
                <KOD_ZR><xsl:value-of select="substring(name(),2,3)"></xsl:value-of></KOD_ZR>
                <NAZWA><xsl:value-of select="@opis"></xsl:value-of></NAZWA>
                <PRZEPLYW>Z</PRZEPLYW>
            </Zrodlo>
        </xsl:for-each>
    </xsl:template>
    
    
    


</xsl:stylesheet>
